import React, { useState, useEffect } from 'react'
import Link from 'next/link'

import Head from 'next/head'

import constants from '../constants.json'
import styles from './faq.module.css'

function PasswordSection() {
  return (
    <>
      <div className={'manualBody'}>
        <p>
          Ha ezt olvasod valszeg már neked is van. Azért lett bevezetve, hogy
          nagyjából zárt legyen a felhasználók köre.
        </p>
        <ul>
          <li>Minden felhasználónak más jelszava van.</li>
          <li>
            Elvileg elég csak 1 szer beírnod, és többet nem kell, de{' '}
            <i>mentsd le biztos helyre a jelszót, hogy később is meglegyen</i>!
            Ha többször kell megadnod, akkor az bug lesz. Ilyenkor ezt{' '}
            <a
              href="http://qmining.frylabs.net/feedback?man"
              target="_blank"
              rel="noreferrer"
            >
              jelentsd
            </a>
            .
          </li>
          <li>
            <i>
              Jelenleg nincs elfelejtett jelszó funkció, ha elfelejted, akkor az
              örökre eltűnik!
            </i>
          </li>
          <li>
            Ha van jelszavad akkor <i>bizonyos határok között</i> te is{' '}
            <a
              href="https://qmining.frylabs.net/pwRequest?man"
              target="_blank"
              rel="noreferrer"
            >
              tudsz generálni
            </a>{' '}
            másoknak (ncore style).
          </li>
          <li>
            Saját jelszavadat ne oszd meg, mivel egyszerre korlátozott helyen
            lehetsz belépve, máshol automatikusan ki leszel jelentkeztetve. (meg
            minek, ha tudsz adni másoknak az előző pont alapján)
          </li>
          <li>
            Mivel senkinek sincs felhasználóneve, csak egy UserID (amit bal alul
            találsz), így az egész teljesen anonim. Emiatt a jelszavakat nem
            lehet megváltoztatni, hogy a szükséges komplexitás megmaradjon.
          </li>
        </ul>
      </div>
    </>
  )
}

function FAQSection() {
  return (
    <>
      <div className={'manualBody'}>
        <ul>
          <li>
            <b>
              Hogy kell a scriptet telepíteni, milyen oldalakon működik és hogy
              működik?
            </b>
            <Link href="/script">
              <a>Ezen az oldalon van leírva</a>
            </Link>{' '}
          </li>
          <li>
            <b>
              Lehet-e valahol szerkeszteni, törölni, illetve manuálisan
              hozzáadni a meglévő kéréseket?
            </b>
            Igen,{' '}
            <a
              href={`${constants.siteUrl}dataeditor`}
              target="_blank"
              rel="noreferrer"
            >
              ezen az oldalon
            </a>{' '}
            van lehetőség erre.
          </li>
          <li>
            <b>
              A teszt ellenőrző oldal nem elérhető. Ilyenkor lehet valamit
              tenni, hogy mégis el legyenek mentve a válaszok?
            </b>
            A{' '}
            <a
              href={`${constants.siteUrl}dataeditor`}
              target="_blank"
              rel="noreferrer"
            >
              dataeditor
            </a>{' '}
            oldal erre is jó, a <i>Kitöltetlen tesztek</i> részhez a script
            automatikusan feltölti a kérdéseket még megoldás közben. Ehhez nincs
            lementve helyes válasz, de ezt te utólag bejelölheted, és
            beküldheted.
          </li>
          <li>
            <b>
              Mennyire anonymus a weboldal/script, és kiderülhet-e hogy
              használom?
            </b>
            A weboldal teljesen anonymus, mindenki csak egy számként van
            nyilvántartva (ami a user ID), random generált uuidv4 jelszavak
            vannak (így nicknevek sem kellenek), és még IP cím sincs sehol
            letárolva szerver oldalon.
            <br />
            Több infó a kockázatok résznél ezen az oldalon.
          </li>
          <li>
            <b>
              Olyan helyeken fut le a script, ahol nem kellene, vagy
              ideiglenesen ki akarom kapcsolni
            </b>
            Tampermonkey bővítmény ikon böngészőben -{'>'} click -{'>'} a
            scriptet kapcsold ki. Csak ne felejtsd el visszakapcsolni ;)
          </li>
          <li>
            <b>
              Túl nagy a kérdést és a választ megjelenítő ablak, nem tudok a
              válaszra kattintani
            </b>
            A felugró ablakot ha minden jól megy akkor a szélénél fogva tudod
            mozgatni, vagy egeret rajtatartva a görgővel tudod állítani az
            áttetszőségét, vagy be tudod zárni jobb felül X-el, vagy egér
            középső gombbal.
          </li>
          <li>
            <b>Gombok, %-ok, számok</b>
            <img className={'manual_img'} src="img/6.png" alt="img" />
          </li>
        </ul>
      </div>
    </>
  )
}

function RiskSection() {
  return (
    <>
      <ul>
        <li>
          <b>Bármikor észrevehetik hogy használod a scriptet</b>A weboldalt már
          kevésbé, de úgy nem menti el a kérdéseket a script, mert nem fut.{' '}
          <a
            href={`${constants.siteUrl}dataeditor`}
            target="_blank"
            rel="noreferrer"
          >
            Manuálisan is be lehet küldeni kérdés-válaszokat.
          </a>
          <p />
          A script shadow-root hoz teszi hozzá az összes megjelenített
          elementet, így ezeket szinte lehetetlen detektálni. A moodle
          semmiféleképpen nem látja, hogy milyen más oldalak vannak megnyitva a
          böngésződben. Nem látja az XMLHttp requesteket se, amit a script
          végez. Egy Matomo nevű script látja hogy milyen oldalakra navigálsz a
          moodle-ről, de a script nem linkekkel irányít át, hanem javascript
          eseménnyel, amit nem tud nyomon követni.
          <p />
          Aztán ki tudja ténylegesen hogy lehet
        </li>
        <li>
          <b>Bármikor leállhat a szerver</b>
          És akkor nem bírod megnézni a válaszokat. Erre van az{' '}
          <a
            href="http://qmining.frylabs.net/allqr.txt?man"
            target="_blank"
            rel="noreferrer"
          >
            összes kérdés TXT
          </a>
        </li>
        <li>
          <b>Akármelyik válasz rossz lehet</b>
          Pl.: ha a script rosszul menti le, vagy rossz kérdésre ad választ
        </li>
        <li>
          <b>
            Ha esetleg {'"'}lebukik{'"'} a szerver, és személyes infók
          </b>
          Semmi személyes információ nincs eltárolva szerveren. Egyedüli
          információ amit egyáltalán ki tudnék deríteni az amúgy is az IP címed,
          de az nincs letárolva. Ha nagyon gonosz lennék, akkor a script el
          tudná küldeni a neved és talán még 1-2 adatot a szervernek, de ezt nem
          teszi.
          <p />
          Bizonyíték? A script, weboldal és szerver teljesen nyílt forráskódú,{' '}
          <Link href="/contribute#gitrepo">
            <a>ezek repository-ja publikus</a>
          </Link>{' '}
          (contribute oldal alja), és akármikor felülvizsgálható. A script a te
          böngésződben fut, tampermonkey bővítmény menüjében megtekinthető
          milyen kód fut pontosan.
        </li>
      </ul>
    </>
  )
}

function WebsiteSaveSection() {
  return (
    <>
      <p>
        Ha hibát észlesz, kérlek jelents. Hogy a hibákat a saját gépemen
        reprodukálni tudjam, és könnyen ki bírjam javítani, sokszor jól jön, ha
        egy lementett weboldalt megkapok, amin a hiba történik. Így lehet
        menteni egy oldalt:
      </p>
      <center>
        <img
          style={{ maxWidth: '90%' }}
          src="img/websitesave.png"
          alt="img"
          className={'manual_img'}
        />
        <br />
        <a href="/contact" rel="noreferrer">
          Ide tudod feltölteni
        </a>
      </center>
      <p>
        Mivel nincs hozzáférésem semmilyen egyetemi oldalhoz, így csak így tudom
        hatékonyan tesztelni a scriptet. Ezért hatalmas segítség ha feltöltöd
        azt az oldalt amin hibával találkozol.
      </p>
    </>
  )
}

function ScriptReinstallSection() {
  return (
    <>
      <p>
        Jelenleg két helyről lehet telepíteni a scriptet: greasyforkról és a
        weboldalról. A greasyforkos telepítési lehetőség megszűnt, így ha onnan
        telepítetted, akkor nem lesznek frissítések elérhetők (amik nagyon
        fontosak (de tényleg)). Ezért a következő rövid manővert kellene
        végrehajtani, hogy minden zökkenőmentesen menjen:
      </p>
      <ul>
        <li>Böngésző bővítményeidnél kattints a tampermonkey-ra</li>
        <li>Válaszd ki alulról második opciót, ami dashboard néven fut</li>
        <li>
          Ekkor új tabban felugranak telepített scriptjeid. Keresd meg a
          Moodle/Elearning/KMOOC test help-et, és a sor végén kattints a kuka
          gombra
        </li>
        <li>Ha megkérdezi mondd neki, hogy biztos törölni akarod</li>
        <li>
          Ezután simán kattints{' '}
          <a
            href="http://qmining.frylabs.net/install?man"
            target="_blank"
            rel="noreferrer"
          >
            ide
          </a>{' '}
          a script újratelepítéséhez a weboldalról.
        </li>
        <li>
          Kész! Lehet megkérdezi újra, hogy elérheti-e a szervert, de azt csak
          egyszer. Szokásos módon engedélyezd, hogy le bírja kérni a helyes
          válaszokat
        </li>
      </ul>
      Ezzel semmi adat nem vész el, régi jelszó ugyanolyan jó marad (csak ne
      felejtsd azt el)
    </>
  )
}

function AddSite() {
  return (
    <>
      Jelenleg az, hogy a script melyik oldalakon fut bele van égetve a script
      forráskódjába. Ez itt látható:{' '}
      <a
        rel="noreferrer"
        target="_blank"
        href="https://gitlab.com/MrFry/moodle-test-userscript/-/blob/master/stable.user.js#L52"
      >
        stable.user.js#L52
      </a>
      {'. '}
      Ez azért van így, hogy biztos csak olyan oldalakon fusson a script amit
      támogat is.
      <p />
      Ehhez persze kézzel hozzá lehet adni ideiglenesen bármilyen oldalt, hogy
      kipróbáld ott működik-e. Akár működik, akár nem kérlek szólj, és frissítem
      a scriptet hogy azon a domainen is fusson és működjön alapból.
      <p />
      Egyetem moodle oldalának hozzáadása a scripthez kézzel:
      <ul>
        <li>
          <Link href="/script">
            <a>Először telepítsd a scriptet rendesen</a>
          </Link>{' '}
        </li>
        <li>
          Böngészőben nyisd meg a Tampermonkey bővítményt <br />
          <img className={'manual_img'} src={`img/siteadd/1.png`} />
          <br />
          Itt kattints a Dashboard-ra.
        </li>
        <li>
          Keresd meg a scriptet, majd kattints rá:
          <br />
          <img className={'manual_img'} src={`img/siteadd/2.png`} />
        </li>
        <li>
          A felugró szerkesztőben keresd meg a következő sorokat:
          <br />
          <img className={'manual_img'} src={`img/siteadd/3.png`} />
        </li>
        <li>
          Itt az egyik <i>@require ...</i> sor után egy új sorban írd be az
          egyetemed moodle oldalának címét. Ha ez a cím pl.:{' '}
          <i>https://moodle.egyetem.hu/main/akármi</i>, akkor a következőre írd
          át: <i>https://moodle.egyetem.hu/*</i>. Fenti képen látsz néhány
          példát. <i>A {'"*"'} a végén fontos!</i>
        </li>
        <li>
          Ezután mentsd el (ctrl + s, vagy file {'->'} save). Ha minden jól
          ment, akkor elég frissíteni a moodle oldalát, és a script futni fog
          rajta. Ezek után azon az oldalon amit beírtál meg kell jelennie a
          Tampermonkey menüjében is:
          <br />
          <img className={'manual_img'} src={`img/siteadd/4.png`} />
        </li>
        <li>
          Ha a tesztek közben mégsem megy, akkor ellenőrizd, hogy a beírt moodle
          cím egyezik-e a teszt közbenivel. Ha kell egy kis segítség, kérdésed
          van, nem működik valami, vagy éppen működik, de alapból nincs
          hozzáadva:{' '}
          <Link href="/contact">
            <a>írj a kapcsolat oldalon!</a>
          </Link>
        </li>
      </ul>
    </>
  )
}

const pages = {
  faq: { name: 'Vegyes általános kérdések', component: FAQSection },
  pw: { name: 'Infó jelszavakról', component: PasswordSection },
  risk: { name: 'Kockázatok', component: RiskSection },
  websitedl: {
    name: 'Teszt közbeni hiba jelentése',
    component: WebsiteSaveSection,
  },
  reinstall: {
    name: 'Script újratelepítése',
    component: ScriptReinstallSection,
  },
  addsite: {
    name: 'Futtatás (még) nem támogatott oldalon',
    component: AddSite,
  },
}

export default function FAQ({ router }) {
  const [currPage, setCurrPage] = useState(pages.faq)

  const renderCurrPage = (page) => {
    if (page) {
      return <page.component />
    } else {
      return null
    }
  }

  useEffect(() => {
    router.replace(`${router.asPath.replace('.html', '')}`, undefined, {
      shallow: true,
    })
  }, [])

  useEffect(() => {
    if (router.query.tab) {
      setCurrPage(pages[router.query.tab])
    }
  }, [router.query.tab])

  return (
    <div>
      <Head>
        <title>GYIK - Qmining | Frylabs.net</title>
      </Head>
      <div className={'pageHeader'}>
        <h1>Gyakran Ismételt Kérdések</h1>
      </div>
      <div className={'buttonContainer'}>
        {Object.keys(pages).map((key) => {
          const page = pages[key]
          return (
            <div
              className={`${page === currPage ? 'activeButton' : ''}`}
              key={key}
              onClick={() => {
                setCurrPage(page)

                router.replace(
                  `${router.pathname}?tab=${encodeURIComponent(key)}`,
                  undefined,
                  { shallow: true }
                )
              }}
            >
              {page.name}
            </div>
          )
        })}
      </div>
      <hr />
      <div className={styles.content}>{renderCurrPage(currPage)}</div>
      <hr />
    </div>
  )
}
